import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import java.util.Scanner;
import java.util.concurrent.*;

public class GrafikGUI  implements ActionListener, Runnable {
    JButton but1;
    JLabel lab1;
    JBaumPanel baum1;
    JFrame frame;

    public void zeigeFenster() {
        setSchriftgroesse(14);

        frame = new JFrame();
        frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        frame.setTitle("Tannebaum");
        frame.setLayout(null); 

        baum1 = new JBaumPanel();
        baum1.setBounds(10,80,300,300);
        frame.add(baum1);

        but1 = new JButton("Licht an/aus");
        but1.setBounds(10,10,120,40);
        but1.addActionListener(this);
        frame.add( but1 );

        lab1 = new JLabel("Es weihnachtet sehr");
        lab1.setBounds(10,50,450,30);
        frame.add(lab1);

        frame.pack();
        frame.setSize(500,430);
        frame.setResizable(false);
        frame.setVisible( true );

        // sorgt dafür, dass die run-Methode in dieser Klasse alle 200ms aufgerufen wird.
        ScheduledThreadPoolExecutor stpe = new ScheduledThreadPoolExecutor(1);
        stpe.scheduleAtFixedRate(this, 1000, 100, TimeUnit.MILLISECONDS);

    }

    public void actionPerformed(ActionEvent e) {
        if(e.getSource() == but1) {
            baum1.toggleLight();
        }
        frame.repaint();
    }
    
    public void run() {
        if(baum1 != null) {
            baum1.nextFrame();
        }
        frame.repaint();
    }
    

    void setSchriftgroesse(int s) {
        Font f = new Font("Arial", Font.BOLD, s);

        UIManager.put("Button.font",f);
        UIManager.put("ToggleButton.font",f);
        UIManager.put("RadioButton.font", f);
        UIManager.put("CheckBox.font", f);
        UIManager.put("ColorChooser.font", f);
        UIManager.put("ComboBox.font", f);
        UIManager.put("Label.font",f);
        UIManager.put("List.font", f);
        UIManager.put("MenuBar.font", f);
        UIManager.put("MenuItem.font", f);
        UIManager.put("RadioButtonMenuItem.font", f);
        UIManager.put("CheckBoxMenuItem.font", f);
        UIManager.put("Menu.font", f);
        UIManager.put("PopupMenu.font", f);
        UIManager.put("OptionPane.font", f);
        UIManager.put("Panel.font", f);
        UIManager.put("ProgressBar.font", f);
        UIManager.put("ScrollPane.font", f);
        UIManager.put("Viewport.font", f);
        UIManager.put("TabbedPane.font", f);
        UIManager.put("Table.font", f);
        UIManager.put("TableHeader.font", f);
        UIManager.put("TextField.font", f);
        UIManager.put("PasswordField.font", f);
        UIManager.put("TextArea.font", f);
        UIManager.put("TextPane.font", f);
        UIManager.put("EditorPane.font", f);
        UIManager.put("TitledBorder.font", f);
        UIManager.put("ToolBar.font", f);
        UIManager.put("ToolTip.font", f);
        UIManager.put("Tree.font", f);        
    }

}
